
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>应用系统日志采集解决方案（转） / iVAN</title>

    <meta name="description" content="应用系统日志采集解决方案（转） 概述 基于Flume + MongoDB,对现有的多个应用系统进行日志采集. 特点 采集范围每一次用户请求的请求信息. 数据量大 尽量减少现有系统的改动 数据流图 说明: 首先考虑的结构体系,是直接在应用系统中,将日志数据写到Flume:但是现有的应用系统都是非Maven的,需要在每一个应用系统中添加20+个jar包.为避免这种情况,抽出了一层日志服务,开放webservice服务给应用系统调用,最终形成上述的体系. 日志存储 1.需要解决的问题 1.1 借助Flume,写日志到MongoDB">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">应用系统日志采集解决方案（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>概述</h2>
<p><hr>
<p>基于Flume + MongoDB，对现有的多个应用系统进行日志采集。</p>
<h2>特点</h2>

<ol>
<li>采集范围<br />每一次用户请求的请求信息。</li>
<li>数据量大</li>
<li>尽量减少现有系统的改动</li>
</ol>
<h2>数据流图</h2>
<hr>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iYzNhN2U4MjVjMzcyNWE2ZTRhMzU5NGNmY2YwYzA5Yi5qcGc=.jpg"></p>
<p>说明：</p>
<p>首先考虑的结构体系，是直接在应用系统中，将日志数据写到Flume；但是现有的应用系统都是非Maven的，需要在每一个应用系统中添加20+个jar包。为避免这种情况，抽出了一层日志服务，开放webservice服务给应用系统调用，最终形成上述的体系。</p>
<h2>日志存储</h2>
<p><hr></p>
<h2>1.需要解决的问题</h2>
<h3>1.1 借助Flume，写日志到MongoDB</h3>
<p>参考：<a>Flume学习应用：Java写日志数据到MongoDB</a></p>
<p>- 外网参考：<a href="http://www.cnblogs.com/ywjy/p/5255161.html" rel="external nofollow noreferrer">Flume学习应用：Java写日志数据到MongoDB</a></p>
<h3>1.2 发布webservice服务</h3>
<p>参考：<a>在web项目中发布jaxws</a></p>
<p>- 外网参考：<a href="http://www.cnblogs.com/ywjy/p/5196118.html" rel="external nofollow noreferrer">在web项目中发布jaxws</a></p>
<h2>2.日志服务实现</h2>
<p>一个简单的web项目，对外发布一个webservice服务，实现写日志到Flume。</p>
<h3>2.1 文件结构</h3>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>src/main/java
    |---- cn.sinobest.asj.log
              |---- ISALog.java # 日志服务接口
              |---- SALogImpl.java # 日志服务实现类
    |---- cn.sinobest.asj.log.exception
              |---- InvalidGradeException.java # 表示无效的日志等级
              |---- InvalidFormatExceptioin.java # 表示无效的消息格式（要求是JSON格式字符串）
    |---- cn.sinobest.asj.log.util
              |---- ValidGrade.java # 枚举，所有有效的日志等级（DEBUG, INFO, WARN, ERROR）
              |---- MessageTemplate.java # 消息模板
src/main/resources
    |---- log4j.properties
src/main/webapp
    |---- WEB-INF
              |---- sun-jaxws.xml
              |---- web.xml
    |----  index.jsp # 这个可以忽略
pom.xml</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> </p>
<h3>2.2  文件内容</h3>
<p>你可以直接从<a href="https://github.com/xmov/log-service" rel="external nofollow noreferrer">log-service</a>拿到源代码，并跳过这一节的内容。</p>
<ol>
<li>pom.xml<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre> 1 &lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 2     xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"&gt;
 3     &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;
 4     &lt;groupId&gt;cn.sinobest.asj&lt;/groupId&gt;
 5     &lt;artifactId&gt;log-service&lt;/artifactId&gt;
 6     &lt;packaging&gt;war&lt;/packaging&gt;
 7     &lt;version&gt;0.0.1-SNAPSHOT&lt;/version&gt;
 8     &lt;name&gt;log-service Maven Webapp&lt;/name&gt;
 9     &lt;url&gt;http://maven.apache.org&lt;/url&gt;
10     &lt;dependencies&gt;
11         &lt;dependency&gt;
12             &lt;groupId&gt;junit&lt;/groupId&gt;
13             &lt;artifactId&gt;junit&lt;/artifactId&gt;
14             &lt;version&gt;3.8.1&lt;/version&gt;
15             &lt;scope&gt;test&lt;/scope&gt;
16         &lt;/dependency&gt;
17         &lt;dependency&gt;
18             &lt;groupId&gt;log4j&lt;/groupId&gt;
19             &lt;artifactId&gt;log4j&lt;/artifactId&gt;
20             &lt;version&gt;1.2.16&lt;/version&gt;
21         &lt;/dependency&gt;
22         &lt;dependency&gt;
23             &lt;groupId&gt;commons-logging&lt;/groupId&gt;
24             &lt;artifactId&gt;commons-logging&lt;/artifactId&gt;
25             &lt;version&gt;1.1.1&lt;/version&gt;
26         &lt;/dependency&gt;
27         &lt;!-- for log to Flume --&gt;
28         &lt;dependency&gt;
29             &lt;groupId&gt;org.apache.flume.flume-ng-clients&lt;/groupId&gt;
30             &lt;artifactId&gt;flume-ng-log4jappender&lt;/artifactId&gt;
31             &lt;version&gt;1.6.0&lt;/version&gt;
32         &lt;/dependency&gt;
33         &lt;!-- for jax-ws --&gt;
34         &lt;dependency&gt;
35             &lt;groupId&gt;com.sun.xml.ws&lt;/groupId&gt;
36             &lt;artifactId&gt;jaxws-rt&lt;/artifactId&gt;
37             &lt;version&gt;2.2.10&lt;/version&gt;
38         &lt;/dependency&gt;
39         &lt;!-- for test the log content is a json-format or not --&gt;
40         &lt;dependency&gt;
41             &lt;groupId&gt;org.mongodb&lt;/groupId&gt;
42             &lt;artifactId&gt;mongo-java-driver&lt;/artifactId&gt;
43             &lt;version&gt;2.13.0&lt;/version&gt;
44         &lt;/dependency&gt;
45     &lt;/dependencies&gt;
46     &lt;build&gt;
47         &lt;finalName&gt;log-service&lt;/finalName&gt;
48     &lt;/build&gt;
49 &lt;/project&gt;</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>web.xml
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;web-app xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns="http://java.sun.com/xml/ns/javaee"
         xmlns:web="http://java.sun.com/xml/ns/javaee/web-app_3_0.xsd"
         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_3_0.xsd"
         id="WebApp_ID" version="3.0" metadata-complete="false"&gt;
    &lt;display-name&gt;Archetype Created Web Application&lt;/display-name&gt;
&lt;/web-app&gt;</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>注意：如果是servlet3.0以下的版本，需要额外的配置。</li>
<li>log4j.properties
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre># 配置Log4jAppender，能写日志到Flume
log4j.appender.flumeAvro=org.apache.flume.clients.log4jappender.Log4jAppender
log4j.appender.flumeAvro.Hostname=localhost
log4j.appender.flumeAvro.Port=44444
log4j.appender.flumeAvro.UnsafeMode=true
log4j.appender.flumeAvro.layout=org.apache.log4j.PatternLayout
log4j.appender.flumeAvro.layout.ConversionPattern=%m
# set root logger
log4j.rootLogger=INFO, flumeAvro</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>ISALog.java
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>package cn.sinobest.asj.log;
import javax.jws.WebParam;
import javax.jws.WebService;
import cn.sinobest.asj.log.exception.InvalidFormatExceptioin;
import cn.sinobest.asj.log.exception.InvalidGradeException;
/**
 * SINOBEST ASJ Log - 为实现日志的统一采集和管理.
 *
 * @author lijinlong
 *
 */
@WebService
public interface ISALog {
    /**
     * 日志记录.
     *
     * @param grade
     *            日志等级描述 - 忽略大小写.
     * @param content
     *            日志内容 - 需要为JSON格式的字符串.
     */
    public void log(@WebParam(name = "grade") String grade,
            @WebParam(name = "content") String content)
            throws InvalidGradeException, InvalidFormatExceptioin;
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>SALogImpl.java<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>  1 package cn.sinobest.asj.log;
  2 import javax.jws.WebService;
  3 import org.apache.commons.logging.Log;
  4 import org.apache.commons.logging.LogFactory;
  5 import cn.sinobest.asj.log.exception.InvalidFormatExceptioin;
  6 import cn.sinobest.asj.log.exception.InvalidGradeException;
  7 import cn.sinobest.asj.log.util.MessageTemplate;
  8 import cn.sinobest.asj.log.util.ValidGrade;
  9 import com.mongodb.util.JSON;
 10 @WebService(endpointInterface = "cn.sinobest.asj.log.ISALog")
 11 public class SALogImpl implements ISALog {
 12     static final Log log = LogFactory.getLog(SALogImpl.class);
 13     public void log(String grade, String content) throws InvalidGradeException,
 14             InvalidFormatExceptioin {
 15         checkGrade(grade);
 16         checkContent(content);
 17         ValidGrade vg = ValidGrade.valueOf(grade.toUpperCase());
 18         log(vg, content);
 19     }
 20     /**
 21      * 根据日志等级，调用{@link log}的不同方法记录日志.
 22      *
 23      * @param vg
 24      *            日志等级
 25      * @param content
 26      *            日志内容
 27      */
 28     private void log(ValidGrade vg, String content) {
 29         switch (vg) {
 30         case DEBUG:
 31             log.debug(content);
 32             break;
 33         case INFO:
 34             log.info(content);
 35             break;
 36         case WARN:
 37             log.warn(content);
 38             break;
 39         case ERROR:
 40             log.error(content);
 41             break;
 42         default:
 43             break;
 44         }
 45     }
 46     /**
 47      * 检查日志等级的有效性.
 48      *
 49      * @param grade
 50      *            日志等级描述.
 51      * @throws InvalidGradeException
 52      *             当日志等级无效时，抛出此异常.
 53      */
 54     private void checkGrade(String grade) throws InvalidGradeException {
 55         boolean valid = ValidGrade.isValid(grade);
 56         if (!valid) {
 57             String message = String.format(MessageTemplate.INVALID_GRADE,
 58                     grade, ValidGrade.getEnumContent());
 59             throw new InvalidGradeException(message);
 60         }
 61     }
 62     /**
 63      * 检查日志内容格式的有效性.&lt;br&gt;
 64      * 要求为JSON格式的字符串.
 65      *
 66      * @param content
 67      *            日志内容.
 68      * @throws InvalidFormatExceptioin
 69      *             当日志内容格式无效时，抛出此异常.
 70      */
 71     private void checkContent(String content) throws InvalidFormatExceptioin {
 72         boolean valid = true;
 73         if (content == null || content.isEmpty()) {
 74             valid = false;
 75         } else {
 76             try {
 77                 JSON.parse(content);
 78                 valid = true;
 79             } catch (com.mongodb.util.JSONParseException e) {
 80                 valid = false;
 81             }
 82         }
 83         if (!valid) {
 84             String message = String.format(MessageTemplate.INVALID_FORMAT,
 85                     content);
 86             throw new InvalidFormatExceptioin(message);
 87         }
 88     }
 89     /**
 90      * just for test.
 91      *
 92      * @param args
 93      */
 94     public static void main(String[] args) {
 95         String[][] data = { { "info", "{'name':'ljl','age':26}" },
 96                 { "INFO", "trouble is a friend." },
 97                 { "JOKE", "{'message':'I am feeling down.'}" } };
 98         ISALog ilog = new SALogImpl();
 99         for (String[] dat : data) {
100             String grade = dat[0];
101             String content = dat[1];
102             try {
103                 ilog.log(grade, content);
104             } catch (Exception e) {
105                 e.printStackTrace();
106             }
107         }
108     }
109 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>InvalidGradeException.java
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>package cn.sinobest.asj.log.exception;
/**
 * 表示无效的日志等级.
 * @author lijinlong
 *
 */
public class InvalidGradeException extends Exception {
    private static final long serialVersionUID = 1341726127995938030L;
    public InvalidGradeException(String message) {
        super(message);
    }
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>InvalidFormatExceptioin.java
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>package cn.sinobest.asj.log.exception;
/**
 * 表示无效的日志等级.
 * @author lijinlong
 *
 */
public class InvalidGradeException extends Exception {
    private static final long serialVersionUID = 1341726127995938030L;
    public InvalidGradeException(String message) {
        super(message);
    }
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>ValidGrade.java<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre> 1 package cn.sinobest.asj.log.util;
 2 /**
 3  * 有效的日志等级.
 4  *
 5  * @author lijinlong
 6  *
 7  */
 8 public enum ValidGrade {
 9     DEBUG, INFO, WARN, ERROR;
10     /** 有效日志等级的枚举内容 */
11     private static String enumContent;
12     /**
13      * 获取所有有效的日志等级.
14      *
15      * @return
16      */
17     public static String getEnumContent() {
18         if (enumContent != null &amp;&amp; !enumContent.isEmpty())
19             return enumContent;
20         ValidGrade[] vgs = ValidGrade.values();
21         StringBuilder builder = new StringBuilder(30);
22         for (ValidGrade vg : vgs) {
23             builder.append(vg).append(",");
24         }
25         builder.delete(builder.length() - 1, builder.length());
26         enumContent = builder.toString();
27         return enumContent;
28     }
29
30     /**
31      * 判断日志等级是否有效.
32      * @param grade 日志等级 - 忽略大小写.
33      * @return
34      */
35     public static boolean isValid(String grade) {
36         if (grade == null || grade.isEmpty())
37             return false;
38
39         boolean result = false;
40
41         final String GRADE = grade.toUpperCase();
42         ValidGrade[] vgs = ValidGrade.values();
43         for (ValidGrade vg : vgs) {
44             if (vg.toString().equals(GRADE)) {
45                 result = true;
46                 break;
47             }
48         }
49
50         return result;
51     }
52
53     /**
54      * just for test.
55      * @param args
56      */
57     public static void main(String[] args) {
58         String content = getEnumContent();
59         System.out.println(content);
60
61         String[] testGrade = {"DEBUG", "INFO", "WARN", "ERROR", "TEST"};
62         for (String tg : testGrade) {
63             if (!ValidGrade.isValid(tg)) {
64                 String message = String.format("%s is invalid.", tg);
65                 System.out.println(message);
66             }
67         }
68     }
69 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>MessageTemplate.java
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>package cn.sinobest.asj.log.util;
/**
 * 消息模板.
 * @author lijinlong
 *
 */
public class MessageTemplate {
    /** 无效的消息等级 */
    public static final String INVALID_GRADE = "无效的日志等级[%s]。服务支持的日志等级有：%s。";

    /** 无效的消息内容格式 */
    public static final String INVALID_FORMAT = "无效的日志内容格式:\n%s\n，请检查是否为JSON格式的字符串。";
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>sun-jaxws.xml</p>
<pre>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;endpoints xmlns="http://java.sun.com/xml/ns/jax-ws/ri/runtime"
    version="2.0"&gt;
    &lt;endpoint name="defaultLog" implementation="cn.sinobest.asj.log.SALogImpl"
        url-pattern="/log.action" /&gt;
&lt;/endpoints&gt;</pre>
</li>
</ol>
<h2>应用系统群</h2>
<hr></p>
<h2>1.需要考虑的问题</h2>
<h3>1.1 拦截</h3>
<p>使用Filter可以实现拦截。</p>
<h3>1.2 组织日志内容</h3>
<p>视需求而定，当前仅对request中的部分信息进行了采集。</p>
<h3>1.3 格式化</h3>
<p>日志信息需要格式化为JSON字符串，才能正确的写到MongoDB。</p>
<h3>1.4 请求webservice服务</h3>
<p>参考：<a>基于wsimport生成代码的客户端</a></p>
<p>- 外网参考：<a href="http://www.cnblogs.com/ywjy/p/5196064.html" rel="external nofollow noreferrer">基于wsimport生成代码的客户端</a></p>
<h2>2. demo</h2>
<h3>2.1 文件结构图</h3>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>src
 |---- cn.sinobest.asj.log
           |----  LogFilter.java
 |---- cn.sinobest.asj.log.wsimport # 存放wsimport生成的代码
           # 省略
basic
 |---- WEB-INF
           |---- web.xml</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<h3>2.2 文件内容</h3>

<ol>
<li>LogFilter.java<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre> 1 package cn.sinobest.asj.log;
 2 import java.io.IOException;
 3 import java.net.MalformedURLException;
 4 import java.net.URL;
 5 import java.util.Date;
 6 import java.util.HashMap;
 7 import java.util.Map;
 8 import javax.servlet.Filter;
 9 import javax.servlet.FilterChain;
10 import javax.servlet.FilterConfig;
11 import javax.servlet.ServletException;
12 import javax.servlet.ServletRequest;
13 import javax.servlet.ServletResponse;
14 import javax.servlet.http.HttpServletRequest;
15 import org.apache.commons.logging.Log;
16 import org.apache.commons.logging.LogFactory;
17 import org.json.JSONObject;
18 import cn.sinobest.asj.log.wsimport.ISALog;
19 import cn.sinobest.asj.log.wsimport.InvalidFormatExceptioin_Exception;
20 import cn.sinobest.asj.log.wsimport.InvalidGradeException_Exception;
21 import cn.sinobest.asj.log.wsimport.SALogImplService;
22 public class LogFilter implements Filter {
23     static final Log log = LogFactory.getLog(LogFilter.class);
24     static final String WSDL_LOCATION = "http://localhost:8080/logserv/log.action?wsdl";
25     @Override
26     public void destroy() {
27     }
28     @Override
29     public void doFilter(ServletRequest request, ServletResponse response,
30             FilterChain chain) throws IOException, ServletException {
31         try {
32             log(request);
33         } catch (InvalidFormatExceptioin_Exception e) {
34             e.printStackTrace();
35         } catch (InvalidGradeException_Exception e) {
36             e.printStackTrace();
37         } finally {
38             chain.doFilter(request, response);
39         }
40     }
41     private void log(ServletRequest request) throws MalformedURLException,
42             InvalidFormatExceptioin_Exception, InvalidGradeException_Exception {
43         Map&lt;String, Object&gt; data = new HashMap&lt;String, Object&gt;();
44         data.put("appid", "zfba");
45         data.put("time", new Date());
46         data.put("localAddr", request.getLocalAddr());
47         data.put("localName", request.getLocalName());
48         data.put("localPort", request.getLocalPort());
49         data.put("remoteAddr", request.getRemoteAddr());
50         data.put("remoteHost", request.getRemoteHost());
51         data.put("remotePort", request.getRemotePort());
52         // data.put("serverName", request.getServerName());
53         // data.put("serverPort", request.getServerPort());
54         HttpServletRequest hrequest = (HttpServletRequest) request;
55         data.put("pathInfo", hrequest.getPathInfo());
56         data.put("pathTranslated", hrequest.getPathTranslated());
57         data.put("remoteUser", hrequest.getRemoteUser());
58         data.put("requestURI", hrequest.getRequestURI());
59         data.put("requestURL", hrequest.getRequestURL());
60         data.put("servletPath", hrequest.getServletPath());
61         JSONObject cont = new JSONObject(data);
62         URL url = new URL(WSDL_LOCATION);
63         SALogImplService ss = new SALogImplService(url);
64         ISALog service = ss.getSALogImplPort();
65         service.log("info", cont.toString());
66     }
67     @Override
68     public void init(FilterConfig arg0) throws ServletException {
69     }
70 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
<li>web.xml<br />这里仅贴出新增的内容：
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>    &lt;!-- 测试日志 --&gt;
    &lt;filter&gt;
        &lt;filter-name&gt;log-filter&lt;/filter-name&gt;
        &lt;filter-class&gt;cn.sinobest.asj.log.LogFilter&lt;/filter-class&gt;
    &lt;/filter&gt;
    &lt;!-- 测试日志 --&gt;
    &lt;filter-mapping&gt;
        &lt;filter-name&gt;log-filter&lt;/filter-name&gt;
        &lt;url-pattern&gt;/*&lt;/url-pattern&gt;
    &lt;/filter-mapping&gt;</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></li>
</ol>
<h2>测试</h2>
<hr>
<ol>
<li>启动MongoDB<br />参考《Flume学习应用：Java写日志数据到MongoDB》</li>
<li>配置并启动Flume<br />参考《Flume学习应用：Java写日志数据到MongoDB》</li>
<li>启动日志服务<br />参考《在web项目中发布jaxws》</li>
<li>启动应用系统，并进行访问</li>
<li>查看MongoDB数据库<br />参考《Flume学习应用：Java写日志数据到MongoDB》</li>
</ol>
<h2>附录</h2>
<hr></p>
<h2>相关文章</h2>

<ol>
<li><a>Flume学习应用：Java写日志数据到MongoDB</a><br />博客园：<a href="http://www.cnblogs.com/ywjy/p/5255161.html" rel="external nofollow noreferrer">Flume学习应用：Java写日志数据到MongoDB</a></li>
<li><a>在web项目中发布jaxws</a><br />博客园：<a href="http://www.cnblogs.com/ywjy/p/5196118.html" rel="external nofollow noreferrer">在web项目中发布jaxws</a></li>
<li><a>基于wsimport生成代码的客户端</a>博客园：<a href="http://www.cnblogs.com/ywjy/p/5196064.html" rel="external nofollow noreferrer">基于wsimport生成代码的客户端</a></li>
</ol>
<p> </p>
<p> </p>
<p>http://www.cnblogs.com/ywjy/p/5259291.html</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-30 11:03:35</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/%e8%a7%a3%e5%86%b3%e6%96%b9%e6%a1%88/" title="解决方案">解决方案</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/mongodb/" title="mongodb">mongodb</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/xml/" title="xml">xml</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/exception/" title="exception">exception</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/servlet/" title="servlet">servlet</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/log/" title="LOG">LOG</a>, <a href="https://www.iamivan.net/tag/put/" title="put">put</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>应用系统日志采集解决方案（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLOavWM.html" rel="bookmark">intelligentminer数据仓库解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当用户的数据积累到一定数量时,这些数据的某些潜在联系.分类.推导结果和待发现价值隐藏在其中,我们可以使用数据发掘工具帮助发现这些有价值的数据,ibm在这方面的工具就是intelligentminer.ibmintelligentminer被选为业界最佳数据采集工具,赢得了dm读者奖.除了数据仓库和数据挖掘解决方案,ibm还在此基础上开发了一系列行业解决方案及应用程序. 1．ibm数据挖掘工具 intelligentminer通过其世界领先的独有技术,例如典型数据集自动生成.关联发现.序列规律发现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWl24Ep.html" rel="bookmark">如何在传输结构体数据的同时&comma;完成结构体中变量数据的采集&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 最近在做一个项目,自己负责的主要工作是将定义好的结构体中的变量的数据传出来,以及matlab计算后传回来的数据进行解算并显示结构体1:传递初始化数据-没有问题结构体2:实时传递摇杆采集的数据-有问题结构体3:传递自动飞行数据-没有问题结构体4:接受matlab结算的数据,并进行显示(暂时还没有测试)现在遇到的问题,主要是:我需要实时传递摇杆采集的数据并传递出去这是按钮事件,当点击按钮之后开始传递结构体的数据SendUAV_ManualPilotpSendUAV_ManualPilot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7xgaab.html" rel="bookmark">大家写个自动采集VeryCD标题的程序吧，好多励志，很不错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 大家写个自动采集VeryCD标题的程序吧,好多励志,很不错 解决方案 解决方案二:其实只要问那边站长要就可以了再说采集这个也麻烦,几天换一个,采集这种变化率很低的东西,还不如人力去采集解决方案三:up解决方案四:呵呵解决方案五:up解决方案六:几分钟就换好几个的解决方案七:恩,想想看啊,使用HttpWebRequest和HttpWebResponse在做页面的请求和下载,使用正则将&lt;title&gt;&lt;/title&gt;之间的数据取出来,分析这个要是一个最新的励志的话,存入数据库中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8ay2b.html" rel="bookmark">有没什么采集器能对口碑网数据进行采集</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 有没什么采集器能对口碑网数据进行采集 解决方案 解决方案二: 采集新闻?去试下小孔子			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPqD5p.html" rel="bookmark">《云安全原理与实践》&mdash;&mdash;2&period;4　云计算安全设计原则</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 云计算安全设计原则 云计算作为一种新兴的信息服务模式,尽管会带来新的安全风险与挑战,但其与传统IT信息服务的安全需求并无本质区别,核心需求仍是对应用及数据的机密性.完整性.可用性和隐私性的保护.因此,云计算安全设计原则应从传统的安全管理角度出发,结合云计算自身的特点,将现有成熟的安全技术及机制延伸到云计算安全设计中,满足云计算的安全防护需求.2.4.1 最小特权最小特权原则是云计算安全中最基本的原则之一,它指的是在完成某种操作的过程中,赋予网络中每个参与的主体必不可少的特权.最小特权原则			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmDdaz.html" rel="bookmark">VS2013 MVC5程序无法启动。各位帮忙看看怎么解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如图新创建的MVC5项目,未修改任何代码,直接F5调试,就出现这个了...是什么问题?怎么解决?刚升级的Update4,没升级之前是OK的 解决方案 解决方案二:设置位启动项目了?看看系统日志报的什么错.iisexpress没启动起来解决方案三:再不行就去控制面板-&gt;程序里面修复下VS解决方案四:引用1楼kongwei521的回复: 设置位启动项目了?看看系统日志报的什么错.iisexpress没启动起来 启动项目设置了.iisexpress启动了这个怎么看系统日志?解决方案五:换下端			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwr7wp.html" rel="bookmark">数据采集过程中如何防止被遮蔽ip地址？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 采集数据被封ip该怎么办,如何判断出网站都用了哪些仿采集的程序?如何防止被遮蔽ip地址? 解决方案 解决方案二:采一次,换一个IP.解决方案三:亲,你的意思是循环换IP地址,那就是启用一个IP地址来存储识别调用,有没有更好的方案或者说具体流程该如何去设计呢?解决方案四:引用2楼csharp_3golden的回复: 亲,你的意思是循环换IP地址,那就是启用一个IP地址来存储识别调用,有没有更好的方案或者说具体流程该如何去设计呢? 那你只能模拟人的操作习惯,打开一个页面后过个几十秒,再打开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq6LLz.html" rel="bookmark">进销存 库存-正在做进销存管理&comma;库存管理模块中&comma;货架信息除了增删改查之外还需要什么方法&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 正在做进销存管理,库存管理模块中,货架信息除了增删改查之外还需要什么方法? 正在做进销存管理,库存管理模块中,货架信息除了增删改查之外还需要什么方法? 解决方案 库存盘点,对库存进行人工审计之后与系统中的数量进行比对,可以发现是否存在不一致,或者发现库存中有货品损坏则,应该进行一个损益,进行金额的损益计算.同时将数据库中的库存数量进行更新.大概就这些吧,我自己之前也做过.如果还想做得更加详细的话,需要到超市进行实际的需求采集 解决方案二: 增删改查 这就已经包扩了所有,任何项目的模块也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5R6o7z.html" rel="bookmark">大数据&OpenCurlyDoubleQuote;矿工&rdquo; 世界上最艰辛的IT人</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				矿工,应该是这个世界上最辛苦的工人!这让笔者不经联想到,一个月以前,在风风火火的&quot;2016贵阳数博会&quot;上,总理又给中国市场指出了一块新&quot;矿源&quot;--大数据. 大数据&quot;矿工&quot;世界上最艰辛的IT人 &quot;那么问题来了,大数据矿工,你的艰辛别人知道吗?&quot;或许曾今,凑热闹的我们只关注绚丽的数据可视化效果.炫酷的用户画像模型,期待着数据支撑决策后的指点江山--可是,最基础的数据怎么来?城市规划专家曾讲,&quot;我国现阶段城市人口最基础真实			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrWZ4p.html" rel="bookmark" class="title">为什么网购主机那么便宜？网购电脑主机靠谱吗？</a>
					<div>
						  在品牌台式机性价比不高的情况下,自己配一台组装机现在是绝大部分用户的选择.不过,DIY装机也是一门学问,对电脑一窍不通的用户可就犯了难!毕竟各种配件装在一起需要考虑兼容性以及针对自身的适用性,最重 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnLP2b.html" rel="bookmark" class="title">教你如何缩小SQL SERVER日志文件</a>
					<div>
						前几天也碰到日志文件过大的问题,数据库实际大小为600M, 日志文件实际大小为33M, 但日志文件占用空间为2.8G!!! 试了多种方式,SHIRNK DATABASE, TRUNCATE LOG F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgOG8M.html" rel="bookmark" class="title">用JavaScript打造搜索工具栏</a>
					<div>
						javascript 电子科技大学软件学院03级2班 周银辉 一:最终效果 二:原理 如果你在Yahoo中搜索&quot;中国&quot;,那么在浏览器的地址栏将得到这样一串地址:http://sea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7EKKM.html" rel="bookmark" class="title">Photoshop外挂KPT7&period;0终极应用</a>
					<div>
						一.什么是滤镜 photoshop 滤镜可以分为三种类型:内阙滤镜.内置滤镜(自带滤镜).外挂滤镜(第三方滤镜).内阙滤镜是指内阙于 photoshop 程序内部的滤镜(共6组24支),这些是不能删除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzD1Rrb.html" rel="bookmark" class="title">网站做了网站优化工作的表现形式</a>
					<div>
						据不完全统计,在中国网民的数量就有着将近5亿人口的庞大数量,由此可以看到网络市场的发展速度,于是很多人都开始往网络市场去靠.很多公司企业,甚至个人店铺都纷纷去做网站,想以此来打开网络营销大门,要想打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd9Wxz.html" rel="bookmark" class="title">ASP&period;NET中WebForm组件CheckBoxList编程&lpar;4&rpar;</a>
					<div>
						asp.net|web|编程 五． 文中源程序代码(Check.aspx)和执行的界面:       下图是执行了下列源程序代码(Check.aspx)后,生成的界面:             Che ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKlaOM.html" rel="bookmark" class="title">python中zip和unzip数据的方法</a>
					<div>
						  本文实例讲述了python zip和unzip数据的方法.分享给大家供大家参考.具体实现方法如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYevlb.html" rel="bookmark" class="title">Linux 本编辑器vim显示utf-8文档乱码的解决方法</a>
					<div>
						  在Linux系统操作中,Vim是文本编辑器,在使用Vim的时候,居然显示utf-8文档乱码,遇到这种情况要如何解决呢?下面小编就给大家介绍下Linux如何解决Vim显示utf-8文档乱码问题,一起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1OeWb.html" rel="bookmark" class="title">PE桌面背景怎么修改</a>
					<div>
						  PE桌面背景怎么修改          经常使用PE的话看到的都是一个桌面背景,想不想换一下品味呢?下面就来说说最简单的修改PE背景图的方法: 大部分PE的桌面壁纸都在OP.WIM里面的桌面背景目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze79BwM.html" rel="bookmark" class="title">explorer&period;exe 服务器运行失败 的解决方法</a>
					<div>
						当您点击屏幕分辨率和个性化就出现 explorer.exe服务器运行失败的窗口,或者打开计算机都会出现. 我一开始以为是可能安装补丁错误了 然后我全部删掉 还是这样 纠结....还有.rar(解压包) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Eo1p.html" rel="bookmark" class="title">电脑电源检测方法</a>
					<div>
						1 人为唤醒电源检测 简单来说就是接电脑主板 20 针的插头,用一根导线(如一个细铁丝,具体 大家发挥想象) 一头插绿色的线, 一头插黑色的线(有 8 根任意其一), 若电源风扇转了就说明电源好了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNQBZM.html" rel="bookmark" class="title">海马苹果助手和爱思助手哪个好用？</a>
					<div>
						  爱思助手和海马助手对比详解: 相同点:两者都是专注于苹果机型的苹果助手软件.免费提供海量正版苹果软件.热门游戏.苹果铃声.高清壁纸,免 AppIe ID 高速一键下载,是简单易用的苹果设备管理工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badnngz.html" rel="bookmark" class="title">如何将XMind思维导图上传</a>
					<div>
						  1.确认准备工作完成后,点击[文件]中的&quot;分享到XMind.net&quot;,或者直接点击工具栏中的上传图标. 2.在跳出的登录窗口中输入XMind ID,若已经登录,便可直接条过这一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72B7dp.html" rel="bookmark" class="title">国行2015款新Macbook Air&sol;Pro正式开售</a>
					<div>
						  苹果在春季发布会上除了推出Apple Watch及全新Macbook,另外针对现有的Macbook Air及Pro系列电脑也进行了常规更新.日前,苹果中国官网商店已正式销售2015款的MacBoo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24ewkp.html" rel="bookmark" class="title">电脑删除文件夹失败提示system的权限怎么办？</a>
					<div>
						  电脑删除文件夹失败提示system的权限怎么办?我们在删除一些系统上面的东西的时候,竟然会收到系统提示&quot;您需要来自system的权限&quot;这时候怎么办呢? 1.首先我们找到想要删除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWBm9p.html" rel="bookmark" class="title">iOS设计模式 - 桥接</a>
					<div>
						iOS设计模式 - 桥接   示意图   说明 1. 桥接模式为把抽象层次结构从实现中分离出来,使其可以独立变更,抽象层定义了供客户端使用的上层抽象接口,实现层次结构定义了供抽象层次使用的底层接口,实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Grlz.html" rel="bookmark" class="title">hql-关于Hql语句，这条语句为什么查不出数据</a>
					<div>
						问题描述 关于Hql语句,这条语句为什么查不出数据 hql = &quot;from A a where a.timeDate &lt;= &quot;+time+&quot; and a.name  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZY9Ob.html" rel="bookmark" class="title">oracle-shell调用gp把查询结果集写入文件，如何做啊</a>
					<div>
						问题描述 shell调用gp把查询结果集写入文件,如何做啊 sqlplus -S /nolog &lt; JCGZ20150701000001.log 这个是oracle 还有如何追加 我不想每次都删 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32Xjgz.html" rel="bookmark" class="title">c&num;二维数组声明简单例子</a>
					<div>
						 protected void Page_Load(object sender, EventArgs e)         {             if (!IsPostBack)         ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6EjZM.html" rel="bookmark" class="title">吴通通讯网上申购系统</a>
					<div>
						本报讯 今日http://www.aliyun.com/zixun/aggregation/32549.html&quot;&gt;吴通通讯(300292,股吧)(300292)1340万股,将通过深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEv56p.html" rel="bookmark" class="title">java-谁知道68行到底哪里错了&quest;</a>
					<div>
						问题描述 谁知道68行到底哪里错了? 谁知道68行到底哪里错了?用socket做超市管理系统java编程,输入产品编号会提示商品,但是却有报错,怎么回事? 解决方案 断点不会用的话,把这个方法拆开 分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjmJ9p.html" rel="bookmark" class="title">WinForm的RadioButton使用小技巧</a>
					<div>
						有时候在一个窗体中有比较多的RadioButton,它们往往是作为取数据.业务逻辑等操作的条件.例如下图例子所示:   用户选择&quot;全部&quot;则会带出全部符合条件数据.选择了&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr0WrM.html" rel="bookmark" class="title">Application&lowbar;Error 中有错误，但是我不知道怎么定位</a>
					<div>
						问题描述 Global.asax中的Application_Error会被断点定位到,因为有一个未被处理的错误但是我不知到在那里引发的这个错误,错误的内容是什么如果我忽略他,我的代码没有任何问题的完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYYXGp.html" rel="bookmark" class="title">android-Android照相机开发遇到的问题</a>
					<div>
						问题描述 Android照相机开发遇到的问题 在实现Android照相机功能的时候,拍照成功保存下来的图片,因为在Manifest文件设置屏幕显示为:&quot;landscape&quot;&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94j5db.html" rel="bookmark" class="title">文本文件和二进制文件的区别</a>
					<div>
						讲的很透彻 从文件编码的方式来看,文件可分为ASCII码文件和二进制码文件两种. ASCII文件也称为文本文件,这种文件在磁盘中存放时每个字符对应一个字节,用于存放对应的ASCII码.例如,数5678 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZJAKp.html" rel="bookmark" class="title">避免&amp;amp&semi;quot&semi;Physics Space Locked&amp;amp&semi;quot&semi;错误</a>
					<div>
						在一些cocos2d中使用物理引擎的代码中,往往会出现如下错误: Aborting due to Chipmunk error: You cannot manually reindex objects ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRrAep.html" rel="bookmark" class="title">dnn目前能否与短信系统结合，能否制作wap网站</a>
					<div>
						问题描述 刚刚开始学习dotnetnuke,很多问题不是很懂,不知道它能否与短信系统结合,目前是否已经有了成熟的短信模块,并且能否只用dnn的模块制作一个wap网站呢?请高手赐教 解决方案 解决方案二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRDlVb.html" rel="bookmark" class="title">阿里近期投资引质疑</a>
					<div>
						腾讯科技讯 7月8日,据外媒报道,在企业治理专家和投资者看来,与阿里巴巴集团创始人马云有关的一系列投资交易向市场发出了警示信号. 目前,阿里巴巴集团正在筹备在美国市场IPO(首次公开招股)上市的交易, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZXk2p.html" rel="bookmark" class="title">Opera中国区总裁兼北界创想（北京）软件有限公司总经理</a>
					<div>
						从Opera到欧朋 时间:2011年12月 地点:北京 嘉宾: 宋麟 Opera中国区总裁兼北界创想(北京)软件有限公司总经理 1966年,古永锵出生于香港,14岁就求学于澳大利亚,五年后去了美国,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1y7Bb.html" rel="bookmark" class="title">莱宝高科创历史新高</a>
					<div>
						近期A股市场持续下跌,多数个股遭遇重挫,但也有少数个股走出独立行情,如莱宝高科(002106)昨日上涨4.4%,报收28.49元,再创历史新高. 该股自2008年10月探出3.72元(复权价)的历史低 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.067 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
